//+------------------------------------------------------------------+
//|                                   Aget - Elliot Confirm V003.mq4 |
//|                       Copyright  2006, Mehrdad_F Software Corp. |
//|                                            http://www.fxpars.com |
//+------------------------------------------------------------------+
// This is new version of Elliot confirm or Aget Data for AdvancedGET EOD 7.6 or 8.00.
// It has additional external input called "Zarib".
// For example If you want 10M chart you can use this indicator on 1M with Zarib=10 or 5M with Zarib=2.
// Charts : 3M , 7M , 10M , 13M , ... , 2H , 8H , ...
// You can build every charts with every timeframe that you want.
// Best Regards.
// Mehrdad_F
// 28 March 2006
#property copyright "Copyright  2006, Mehrdad_F Software Corp."
#property link      "http://www.fxpars.com"
#property indicator_chart_window
extern double Zarib=1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   Comment("AgetData");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   Comment(" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
   int counted_bars=IndicatorCounted();
//----   
   int handle;
   int cnt,shift;
   int _year = 1930;
   int _month = 1;
   int _day = 1;
   double _Open1, _Close1, _High1, _Low1, _Volume1, _Open2, _Close2, _High2, _Low2;
   string strline;
   string name_file;
   name_file = Symbol()+DoubleToStr((Period()*Zarib),0)+ ".csv";
   //Print("name_file=", name_file);
   handle = FileOpen(name_file , FILE_CSV|FILE_WRITE, "\t");
   if(handle<1)
      {
      Print("can't open file error-",GetLastError());
      return(0);
      }
   strline = "Date,Open,High,Low,Close,Volume,Adj Close";
   FileWrite(handle, strline);
   shift=17000;
   if (shift > Bars-3) shift=Bars-3;
   for(shift=Bars-3;shift>=Bars-15;shift--)
   {
       if (StringSubstr(TimeToStr(Time[shift],TIME_MINUTES),3,2) == "00") break;
   }
   for (cnt=shift;cnt>=0;cnt--)
      {
      if (Period() < 1440)
         {
         strline = DoubleToStr(_year,0);
         if (_month < 10)
            strline = strline + "0" + DoubleToStr(_month,0);
         else
            strline = strline + DoubleToStr(_month,0);
      
         if (_day < 10)
            strline = strline + "0" + DoubleToStr(_day,0);
         else
            strline = strline + DoubleToStr(_day,0);
         _Open1 =Open[cnt];
         _Close1=Close[cnt];
         _High1 =High[cnt];
         _Low1  =Low[cnt];
         _Volume1 = Volume[cnt];
         if (cnt>Zarib-1)
         {
            for(int count=Zarib;count>1 && cnt>=0;count--)
            {
               cnt--;
               _Open2 =Open[cnt];
               _Close2=Close[cnt];
               _High2 =High[cnt];
               _Low2  =Low[cnt];
               //------------------
               _Close1=_Close2;
               _High1 =MathMax(_High1,_High2);
               _Low1  =MathMin(_Low1,_Low2);
               _Volume1 = _Volume1 + Volume[cnt];
            }
         }
         string strtime = TimeToStr(Time[cnt],TIME_DATE|TIME_SECONDS);
         strline = strline + "," + DoubleToStr(_Open1,Digits) + "," + DoubleToStr(_High1,Digits) + "," + DoubleToStr(_Low1,Digits) + "," + DoubleToStr(_Close1,Digits) + "," + DoubleToStr(_Volume1,0)+ "," + DoubleToStr(_Close1,Digits);
         }
      else
         {
         strline = TimeToStr(Time[cnt],TIME_DATE|TIME_SECONDS);
         strline = StringSubstr(strline,0,4) + StringSubstr(strline,5,2) + StringSubstr(strline,8,2);
         strline = strline + "," + DoubleToStr(Open[cnt],Digits) + "," + DoubleToStr(High[cnt],Digits) + "," + DoubleToStr(Low[cnt],Digits) + "," + DoubleToStr(Close[cnt],Digits) + "," + DoubleToStr(Volume[cnt],0)+ "," + DoubleToStr(Close[cnt],Digits);
         }
      FileWrite(handle, strline);
      // Start of build virtual date.
      if (Period() < 1440)
         {
         if (_day < 24) 
            _day++; 
         else 
            {
            _day = 1;
            _month++;
            if (_month > 12)
               {
               _month = 1;
               _year++;
               }
            }
         }
      // End of build virtual date.
      }
   FileClose(handle);

//----
   return(0);
  }
//+------------------------------------------------------------------+